﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

/////////////////////////////////////
// Plugin class
cr.plugins_.ppstudiomty_kong_plugin = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{
	var pluginProto = cr.plugins_.ppstudiomty_kong_plugin.prototype;
		
	/////////////////////////////////////
	// Object type class
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};

	var typeProto = pluginProto.Type.prototype;

	typeProto.onCreate = function()
	{
		
	};

	/////////////////////////////////////
	// Instance class
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;

		//this.kongLoaded = false;
		// Initialise object properties
		//this.testProperty = 0;
	};
	
	var instanceProto = pluginProto.Instance.prototype;
	
	instanceProto.onCreate = function()
	{
		
		console.log("Kongregate API in process...");
		// Read properties set in C3
		//this.testProperty = this.properties[0];
		if (typeof kongregateAPI === "undefined"){
			console.log("Kongregate API NOT loaded");
			this.kongLoaded = false;
		}
		else{
			console.log("Kongregate API Found");
			console.log(kongregateAPI);
			this.kongLoaded = true;
		}

		kongregateAPI.loadAPI(function(){
			window.kongregate = kongregateAPI.getAPI();
				// You can now access the Kongregate API with:
				// kongregate.services.getUsername(), etc
				// Proceed with loading your game...
			});
			
			console.log("Callback function for loading API...");
	};
	
	instanceProto.saveToJSON = function ()
	{
		return {};
	};
	
	instanceProto.loadFromJSON = function (o)
	{
	};
	
	/**BEGIN-PREVIEWONLY**/
	instanceProto.getDebuggerValues = function (propsections)
	{
	};
	/**END-PREVIEWONLY**/

	//////////////////////////////////////
	// Conditions
	function Cnds() {};
	
	Cnds.prototype.IsAPILoaded = function ()
	{
		return this.kongLoaded;
		/*if (typeof kongregateAPI.getAPI() === "undefined")
			return false;
		else
			return true;*/
	};
	
	pluginProto.cnds = new Cnds();

	//////////////////////////////////////
	// Actions
	function Acts() {};

	Acts.prototype.SubmitScore = function (stat,val)
	{
		kongregate.stats.submit(stat, val);
	};
	
	pluginProto.acts = new Acts();

	//////////////////////////////////////
	// Expressions
	function Exps() {};
	
	/*Exps.prototype.Double = function (ret, number)
	{
		ret.set_float(number * 2);
	};*/
	
    Exps.prototype.GetUserName = function (ret) {
        let user = kongregate.services.getUsername();
        ret.set_string(user || "");
    };
	
	
	pluginProto.exps = new Exps();

}());